import { IAnimateOption, IAttribute, IElements, IModel, IModelUniform } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class RadarModel extends BaseModel {
    meter2coord: number;
    private isMeter;
    getUninforms(): IModelUniform;
    getAnimateUniforms(): IModelUniform;
    getAttribute(): {
        attributes: {
            [attributeName: string]: IAttribute;
        };
        elements: IElements;
    };
    initModels(): Promise<IModel[]>;
    /**
     * 计算等面积点图层（unit meter）笛卡尔坐标标度与世界坐标标度的比例
     * @returns
     */
    calMeter2Coord(): void;
    buildModels(): Promise<IModel[]>;
    clearModels(): void;
    protected animateOption2Array(option: Partial<IAnimateOption>): number[];
    protected registerBuiltinAttributes(): void;
}
